use sdl2_sys::SDL_CreateWindowFrom;

use sdl2::event::Event;
use sdl2::keyboard::Keycode;

use sdl2::pixels::{Color};
use std::time::Duration;

use std::ffi::c_void;

use x11::*;


use sdl2::video::Window;



fn main() {
    unsafe {
        //INSERT X11 STUFF
        let x11d = sdl2_sys::XOpenDisplay(std::ptr::null());
        let x11w = sdl2_sys::XRootWindow(x11d, sdl2_sys::XDefaultScreen(x11d));

        //SDL STUFF
        //
        let ctx = sdl2::init().unwrap();

        let vsys = ctx.video().unwrap();
        let win = SDL_CreateWindowFrom(x11w as *mut c_void);

        let window = Window::from_ll(vsys, win);

        //let  img = load_gif_image("../output.gif").unwrap();

        let mut canvas = window.into_canvas().build().unwrap();
        // let tc = canvas.texture_creator();
        // 
        // let width = img.width();
        // let height = img.height();
        //
        // let mut texture = tc.create_texture_streaming(PixelFormatEnum::RGB24, width, height).unwrap();
        // texture.update(None, img.as_rgb8().unwrap(), (width * 3) as usize).unwrap();   
        // 
        // canvas.copy(&texture, None, None).unwrap();
        // canvas.present();
    
        canvas.set_draw_color(Color::RGB(0, 255, 255));
        canvas.clear();
        canvas.present();
        let mut event_pump = ctx.event_pump().unwrap();
        let mut i = 0;
        'running: loop {
            i = (i + 1) % 255;
            canvas.set_draw_color(Color::RGB(i, 64, 255 - i));
            canvas.clear();
            for event in event_pump.poll_iter() {
                match event {
                    Event::Quit { .. }
                    | Event::KeyDown {
                        keycode: Some(Keycode::Escape),
                        ..
                    } => break 'running,
                    _ => {}
                }
            }
            // The rest of the game loop goes here...

            canvas.present();
            ::std::thread::sleep(Duration::new(0, 1_000_000_000u32 / 60));
        }
    }

}


